<?php
namespace Mirasvit\Brand\Repository\BrandPageRepository;

/**
 * Interceptor class for @see \Mirasvit\Brand\Repository\BrandPageRepository
 */
class Interceptor extends \Mirasvit\Brand\Repository\BrandPageRepository implements \Magento\Framework\Interception\InterceptorInterface
{
    use \Magento\Framework\Interception\Interceptor;

    public function __construct(\Magento\Catalog\Model\ResourceModel\Product\CollectionFactory $productCollectionFactory, \Magento\Catalog\Model\Product\Action $productAction, \Mirasvit\Brand\Model\Config\GeneralConfig $config, \Mirasvit\Brand\Api\Data\BrandPageInterfaceFactory $factory, \Mirasvit\Brand\Model\ResourceModel\BrandPage\CollectionFactory $collectionFactory, \Magento\Framework\EntityManager\EntityManager $entityManager, \Magento\Framework\Filter\FilterManager $filter, \Magento\Framework\App\ResourceConnection $resourceConnection)
    {
        $this->___init();
        parent::__construct($productCollectionFactory, $productAction, $config, $factory, $collectionFactory, $entityManager, $filter, $resourceConnection);
    }

    /**
     * {@inheritdoc}
     */
    public function get(int $id) : ?\Mirasvit\Brand\Api\Data\BrandPageInterface
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'get');
        return $pluginInfo ? $this->___callPlugins('get', func_get_args(), $pluginInfo) : parent::get($id);
    }

    /**
     * {@inheritdoc}
     */
    public function save(\Mirasvit\Brand\Api\Data\BrandPageInterface $brandPage) : \Mirasvit\Brand\Api\Data\BrandPageInterface
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'save');
        return $pluginInfo ? $this->___callPlugins('save', func_get_args(), $pluginInfo) : parent::save($brandPage);
    }
}
